@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ Sourcefile smashed together by Peter Schraut on 3 April 2003
@ www.console-dev.de
@
@ extern u8 IsRealGBA(void);
@
@ Returns:
@           0   :   Is Emulator
@           1   :   Is real Gameboy Advance Hardware
@
@ I found this code on the gbadev.org forum at http://forum.gbadev.org
@
@ Here is the complete URL to the post:
@ http://forum.gbadev.org/viewtopic.php?t=910
@
@ And here is the text, in case the website isn't available:
@
@ Posted: Thu Apr 03, 2003 12:23 pm    Post subject:
@
@ ------------------------------------------------------------------------
@
@ found on the yahoo gbadev newsgroup:
@
@ Pete wrote:
@ Does anyone have code for detecting the presence of an emulator?
@
@ Thanks
@
@
@ Neal Tew wrote:
@ This works pretty well. It has to be run from RAM, of course.
@
@ detectGBA: ;returns 0 if emulated
@ mov r0,#0
@ str r0,_0
@ _0: mov r0,#1
@ mov pc,lr
@
@
@ Pete wrote:
@ Thanks, that was exactly what I needed. ;-)
@
@ Cheers,
@ -Pete
@
@ P.S. His code works by overwriting the next instruction with a NOP.
@ On a real CPU, the old contents would have already been fetched,
@ so the overwrite has no effect.
@
@
@ ;)
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.CODE 32
.SECTION .iwram
.GLOBAL IsRealGBA
.ALIGN

IsRealGBA:
    MOV r0,#0
    STR r0,_0
    _0: MOV r0,#1
    MOV pc,lr
@
@ END -> IsRealGBA
@
